searchData={"items":[{"type":"module","title":"Tuftemark","doc":"Tuftemark converts Markdown content into format that is suitable to be used with\n[Tufte CSS](https://github.com/edwardtufte/tufte-css) tool.\n\nTufte CSS layout requires a few things to be applied to the HTML, for example:\n\n- the whole post must be wrapped in ` ` tag\n- content must be split into ` `s around every H2 tag\n- footnotes must be converted into margin notes (compatible with the CSS)\n\nThe `as_html!/2` method is trying to apply all the given transformation to the\noriginally parsed AST, so we get applicable HTML output in the end.","ref":"Tuftemark.html"},{"type":"module","title":"Extra Modifications - Tuftemark","doc":"Some of layout decisions cannot be made automatically, but we can use some super\npowers provided us by default Earmark's Parser.\n\nFor example:\n\n- if we want a paragraph written in sans-serif, we can use Kramdown syntax for\n  attributes: (`{:.sans}`);\n- if we want to provide a citation (as a blockquote), we can use set an attr:\n  `{:cite=\"https://example.com\"}`;\n\nSee all such examples in the TuftemarkTest suite.","ref":"Tuftemark.html#module-extra-modifications"},{"type":"module","title":"Installation - Tuftemark","doc":"The package can be installed by adding `tuftemark` to your list of dependencies\nin `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:tuftemark, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"Tuftemark.html#module-installation"},{"type":"function","title":"Tuftemark.as_html!/2","doc":"Expects a [GitHub Flavored Markdown](https://github.github.com/gfm/) as first argument and list of options\napplicable to [`Earmark.as_html!/2`](https://hexdocs.pm/earmark/Earmark.html#as_html!/2) to pass into other\nEarmark-related modules.","ref":"Tuftemark.html#as_html!/2"},{"type":"function","title":"Tuftemark.convert!/0","doc":"Processes files on a disk, converts Markdown to HTML using `as_html!/2`.","ref":"Tuftemark.html#convert!/0"},{"type":"function","title":"Usage Example - Tuftemark.convert!/0","doc":"```console\nmix run -e \"Tuftemark.convert!()\" -- example.md example.html\n```","ref":"Tuftemark.html#convert!/0-usage-example"},{"type":"module","title":"Tuftemark.Blockquotes","doc":"","ref":"Tuftemark.Blockquotes.html"},{"type":"function","title":"Tuftemark.Blockquotes.process/1","doc":"","ref":"Tuftemark.Blockquotes.html#process/1"},{"type":"module","title":"Tuftemark.Figures","doc":"Converts Markdown images to HTML figures with layout applicable to Tufte CSS.\n\n> [!info]\n>\n> If Markdown defines a `.fullwidth` image that is followed by a paragraph\n> supposed to the its `.caption`, we ignore the caption text (as we are not\n> sure how to render it properly yet). Maybe we will handle it later.\n\n> [!warning]\n>\n> At the original Tufte CSS [page](https://edwardtufte.github.io/tufte-css/),\n> we can see an example of a marginal image (the image of Rhinoceros). Authors\n> wrap a paragraph of text (that is visually right to the left of the marginal\n> image block) inside the marginnote itself.\n>\n> Our current implementation works a bit differently - it renders next\n> paragraph of Markdown text (that goes after the marginal image) as regular\n> `p` that goes after side note.\n>\n> Not a big deal, but it gives slightly other layout and on narrow screens\n> the margin toggle icon (by default it's `⊕`) rendered differently.","ref":"Tuftemark.Figures.html"},{"type":"function","title":"Tuftemark.Figures.process/1","doc":"","ref":"Tuftemark.Figures.html#process/1"},{"type":"module","title":"Tuftemark.Sections","doc":"Split the given AST into sections (by wrapping corresponding pieces of content) around each `h2` tag.","ref":"Tuftemark.Sections.html"},{"type":"function","title":"Tuftemark.Sections.process/1","doc":"","ref":"Tuftemark.Sections.html#process/1"},{"type":"module","title":"Tuftemark.Sidenotes","doc":"","ref":"Tuftemark.Sidenotes.html"},{"type":"function","title":"Tuftemark.Sidenotes.process/1","doc":"","ref":"Tuftemark.Sidenotes.html#process/1"},{"type":"module","title":"Tuftemark.Utils","doc":"Provides access to common helpers used in other parts of the Tuftemark convertor.","ref":"Tuftemark.Utils.html"},{"type":"function","title":"Tuftemark.Utils.sidenote/5","doc":"Generates a set of tags (with proper classes set) to be used as side- or\nmarginal note.\n\nThe main difference is that for sidenotes we must pass truthy `is_numbered`\nto get automatic numbering for them. Marginal notes shall not be numbered.","ref":"Tuftemark.Utils.html#sidenote/5"},{"type":"function","title":"Tuftemark.Utils.wrap_in/2","doc":"Wraps the given AST into another tag as a whole.","ref":"Tuftemark.Utils.html#wrap_in/2"},{"type":"function","title":"Examples - Tuftemark.Utils.wrap_in/2","doc":"iex> ast = [{\"p\", [], [\"Lorem ipsum\"], %{}}]\n    iex> Tuftemark.Utils.wrap_in(ast, \"div\")\n    [{\"div\", [], [{\"p\", [], [\"Lorem ipsum\"], %{}}], %{}}]","ref":"Tuftemark.Utils.html#wrap_in/2-examples"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,49]}}